<?php

/**
 * @file
 * Context configuration and hooks.
 */

/**
 * Implements hook_context_plugins().
 */
function ip_geoloc_context_plugins() {
  $plugins = [];
  $plugins['ip_geoloc_context_reaction_locate_visitor'] = [
    'handler' => [
      'path' => \Drupal::service('extension.path.resolver')->getPath('module', 'ip_geoloc') . '/plugins',
      'file'  => 'ip_geoloc_context_reaction_locate_visitor.inc',
      'class' => 'ip_geoloc_context_reaction_locate_visitor',
      'parent' => 'context_reaction',
    ],
  ];
  return $plugins;
}

/**
 * Implements hook_context_registry().
 */
function ip_geoloc_context_registry() {
  return [
    'reactions' => [
      'locate_visitor' => [
        'title' => t('Locate visitor using GPS/Wifi (if page changed)'),
        'plugin' => 'ip_geoloc_context_reaction_locate_visitor',
      ],
    ],
  ];
}

/**
 * Implements hook_context_page_reaction().
 */
function ip_geoloc_context_page_reaction() {
  if ($plugin = context_get_plugin('reaction', 'locate_visitor')) {
    $plugin->execute();
  }
}
